///home/berryj/link/bin/genMethods "-g" "-t" "DBinGraph*" "-r" "MDBinGraph*" "-I" "LINK/graph/DBinGraph.h" "-y" "display_graphptr" "-m" "mark_graphptr" "-w" "free_graphptr" "-d" "graph" "-f" "_dBinGraph_" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/graph/DBinGraph.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>

void display_graphptr(SCM, SCM, int);
void mark_graphptr(SCM);
void free_graphptr(SCM);

typedef DBinGraph* _DBinGraph_;

#define _DBinGraph_DATA(x) ((DBinGraph**) (EXTDATA(x)))
#define _DBinGraph_IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<DBinGraph* >::type))
#define _DBinGraph_ISNT_DATA(x) (!_DBinGraph_IS_DATA(x))

#define _DBinGraph_CXX_DATA(x) (*(DBinGraph**) (EXTDATA(VAL(x))))
#define _DBinGraph_CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<DBinGraph* >::type))
#define _DBinGraph_CXX_ISNT_DATA(x) (!_DBinGraph_CXX_IS_DATA(x))


static SCM is_DBinGraph_(SCM i)
{
	if (_DBinGraph_CXX_IS_DATA(i))
		return Truth;
	return Ntruth;
}

PRIMITIVE STk_init__dBinGraph_()
{
	Wrapper<_DBinGraph_>::type = STk_new_CXXwrapper_id(
			Wrapper<_DBinGraph_>::name, 
			Wrapper<MDBinGraph* >::name,
			(void (*)(SCM x, SCM port, int mode))
			display_graphptr,
			(void (*)(SCM x))mark_graphptr,
			(void (*)(SCM x))free_graphptr);
	Tcl_InitHashTable(&Register<_DBinGraph_>::objTable, TCL_ONE_WORD_KEYS);
	STk_add_new_cpp_primitive("DBinGraph?", tc_subr_1,
	(PRIMITIVE (*)(...))  is_DBinGraph_);
	return UNDEFINED;
}

void genExtra_dBinGraph_Methods(void);

PRIMITIVE STk_init_methods__dBinGraph_()
{
	genExtra_dBinGraph_Methods();
	return UNDEFINED;
}
